%{
#include <stdio.h>
#include "defs.h"

extern rule	*rulelist;

%}

%union {
	float		y_flt;
	condition	*y_cnd;
	expr		*y_exp;
}

%type <y_cnd> condlist cond
%type <y_exp> expr

%token <y_flt>	FLOAT

%token	EQUATES X Y Z DX DY DZ OR ABS PLUS MINUS DIV MUL

%left	'*' '/'
%left	'+' '-'
%left	'|'
%left	'&'

%%

input	: condlist EQUATES expr ',' expr ',' expr
	  {
		rule	*r;

		rulelist = (rule *)smalloc(sizeof(rule));

		rulelist->conds = $1;
		rulelist->red = $3;
		rulelist->green = $5;
		rulelist->blue = $7;
		rulelist->nxt = (rule *)NULL;
	  }
	| input condlist EQUATES expr ',' expr ',' expr
	  {
		rule	*r;

		for (r = rulelist; r->nxt != (rule *)NULL; r = r->nxt)
			;

		r->nxt = (rule *)smalloc(sizeof(rule));

		r = r->nxt;

		r->conds = $2;
		r->red = $4;
		r->green = $6;
		r->blue = $8;
		r->nxt = (rule *)NULL;
	  }
	;

condlist: cond 
	  {
		$$ = $1;
	  }
	| condlist '&' cond
	  {
		condition	*c;

		for (c = $1; c->nxt != (condition *)NULL; c = c->nxt)
			;

		c->nxt = $3;
		$$ = $1;
	  }
	| condlist '|' cond
	  {
		$$ = (condition *)smalloc(sizeof(condition));

		$$->type = OR;
		$$->u.type2.first = $1;
		$$->u.type2.alt = $3;

		$$->nxt = (condition *)NULL;
	  }
	| '(' condlist ')'
	  {
		$$ = $2;
	  }
	;

cond	: X '[' expr expr ']'
	  {
		$$ = (condition *)smalloc(sizeof(condition));

		$$->type = X;
		$$->u.type1.min = eval($3);
		$$->u.type1.max = eval($4);
		$$->nxt = (condition *)NULL;
	  }
	| Y '[' expr expr ']'
	  {
		$$ = (condition *)smalloc(sizeof(condition));

		$$->type = Y;
		$$->u.type1.min = eval($3);
		$$->u.type1.max = eval($4);
		$$->nxt = (condition *)NULL;
	  }
	| Z '[' expr expr ']'
	  {
		$$ = (condition *)smalloc(sizeof(condition));

		$$->type = Z;
		$$->u.type1.min = eval($3);
		$$->u.type1.max = eval($4);
		$$->nxt = (condition *)NULL;
	  }
	| DX '[' expr expr ']'
	  {
		$$ = (condition *)smalloc(sizeof(condition));

		$$->type = DX;
		$$->u.type1.min = eval($3);
		$$->u.type1.max = eval($4);
		$$->nxt = (condition *)NULL;
	  }
	| DY '[' expr expr ']'
	  {
		$$ = (condition *)smalloc(sizeof(condition));

		$$->type = DY;
		$$->u.type1.min = eval($3);
		$$->u.type1.max = eval($4);
		$$->nxt = (condition *)NULL;
	  }
	| DZ '[' expr expr ']'
	  {
		$$ = (condition *)smalloc(sizeof(condition));

		$$->type = DZ;
		$$->u.type1.min = eval($3);
		$$->u.type1.max = eval($4);
		$$->nxt = (condition *)NULL;
	  }
	;

expr	: FLOAT
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = FLOAT;
		$$->u.f = $1;
	  }
	| X
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = X;
	  }
	| Y
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = Y;
	  }
	| Z
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = Z;
	  }
	| DX
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = DX;
	  }
	| DY
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = DY;
	  }
	| DZ
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = DZ;
	  }
	| ABS '(' expr ')'
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = ABS;
		$$->left = $3;
	  }
	| expr '+' expr
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = PLUS;
		$$->left = $1;
		$$->right = $3;
	  }
	| expr '-' expr
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = MINUS;
		$$->left = $1;
		$$->right = $3;
	  }
	| expr '*' expr
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = MUL;
		$$->left = $1;
		$$->right = $3;
	  }
	| expr '/' expr
	  {
		$$ = (expr *)smalloc(sizeof(expr));

		$$->type = DIV;
		$$->left = $1;
		$$->right = $3;
	  }
	| '(' expr ')'
	  {
		$$ = $2;
	  }
	;

